<?php
/**
 * WoWRoster.net WoWRoster
 *
 * reputation index.php
 *
 * => and many help from  Subxero@EU-Zul'jin
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2002-2007 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: index.php 001 2008-01-22 13:01:07Z tuigii - Nowwhat@EU-Khaz Modan$ - 
 * @link       http://www.wowroster.net
 * @package    reputation
*/

if ( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

global $roster;

require_once ($addon['dir'].'inc/factions_to_en.php');

$roster->output['title'] = $roster->locale->act['reputationinfo'];

// Only get dinsctint reps for guild 'guild_id'

$qry_fct = "SELECT distinct(r.name) faction, p.clientLocale FROM ".
	$roster->db->table('reputation')." r, ".
	$roster->db->table('players')." p ".
	"WHERE r.member_id = p.member_id AND p.guild_id = ".$roster->data['guild_id'];

	if ($addon['config']['reputation_language'] == 0) // 0 = limit to roster selected language only
	{
		$qry_fct .=" AND p.clientLocale = '".$roster->config['locale']."'";	
	}
		
$result_fct = $roster->db->query( $qry_fct ) or die_quietly($roster->db->error(),'Database Error',basename(__FILE__),__LINE__,$qry_fct);
$row_fct = $roster->db->fetch_all($result_fct);
$roster->db->free_result($result_fct);

// First, convert all factions to enUS - this WILL remove factions that are present in several languages
$result_enUS = array();
foreach($row_fct as $record)
{
	$faction_enUS = $Factions_to_en[$record['clientLocale']][$record['faction']];
	if(!in_array($faction_enUS, $result_enUS)) // Only add if not present already
	{
		$result_enUS[] = $faction_enUS;
	}
}

// Convert the 'factions' array in the local language
$result_local = array();
foreach($result_enUS as $record)
{
	$result_local[] = getlanguagefaction($Factions_to_en[$roster->config['locale']], $record);
}

// Sort it
sort($result_local);

// Build faction select box
$choiceForm = '<form action="' . makelink() . '" method="get">'.$roster->locale->act['faction_filter'].'
	<select name="factionfilter" onchange="window.location.href=this.options[this.selectedIndex].value">';
$choiceForm .= '<option value="' . makelink('guild-' . $addon['basename'],true).'">"'.$roster->locale->act['SelectFaction'].'"</option>\n';

foreach($result_local as $faction)
{
	if( isset($_GET['factionfilter']) && stripslashes($_GET['factionfilter']) == $faction )
	{
		$choiceForm .= '  <option value="' . makelink('guild-' . $addon['basename'] . '&amp;factionfilter=' . $faction, true) . '" selected="selected">' . $faction . "</option>\n";
	}
	else
	{
		$choiceForm .= '  <option value="' . makelink('guild-' . $addon['basename'] . '&amp;factionfilter=' . $faction, true) . '">' . $faction . "</option>\n";
	}
}
$choiceForm .= '</select>';
$choiceForm .= '</form><br />';

print $choiceForm;

// If a reputation is selected, build the box with rep levels (standings)

unset($faction_enUS);
if( isset($_GET['factionfilter']) && $_GET['factionfilter'] != makelink('guild-'.$addon['basename']))
{
	$GetSelectedFaction = stripslashes($_GET['factionfilter']);
	// Convert to enUS - prefer first using current roster language
	if(isset($Factions_to_en[$roster->config['locale']][$GetSelectedFaction]))
	{
		$faction_enUS = $Factions_to_en[$roster->config['locale']][$GetSelectedFaction];
		$callinglocale = $roster->config['locale'];
	}
	// Reputation name isn't in current roster language - scan them one by one to find a match
	else
	{
		foreach($roster->multilanguages as $lang)
		{
			if(isset($Factions_to_en[$lang][$GetSelectedFaction]))
			{
				$faction_enUS = $Factions_to_en[$lang][$GetSelectedFaction];
				$callinglocale = $lang;
				break;
			}
		}
	}			
	if(!isset($faction_enUS))
	{
		print '<span style="color:#FF0000;">Error :</span> "'.$GetSelectedFaction.'"';
	}
}

if(isset($faction_enUS))
{
	// Build a SQL set for all possible translations
	$factions  = 'r.name IN (';

	foreach($roster->multilanguages as $lang)
	{
		$factions .= '"'.getlanguagefaction($Factions_to_en[$lang], $faction_enUS).'", ';
	}
	$factions .= '"")';
	
	$query = "SELECT m.clientLocale Clocale, m.name member, r.faction, r.name, curr_rep AS value, ".
		"curr_rep, ".
		"max_rep, ".
		"r.standing ".
		"FROM `".$roster->db->table('reputation')."` r, `".$roster->db->table('players')."` m ".
		"WHERE r.member_id = m.member_id AND m.guild_id = ".$roster->data['guild_id']." AND ".$factions;
	
	if ($addon['config']['reputation_language'] == 0) // 0 = limit to roster selected language only
	{
		$query .=" AND m.clientLocale = '".$roster->config['locale']."'";	
	}

	$result = $roster->db->query($query) or die_quietly($roster->db->error(),'Database Error',basename(__FILE__),__LINE__,$query);
	$membersforthisreputation = $roster->db->fetch_all($result);
	$roster->db->free_result($result);
	
	// Old fashioned 'PHP 4' compatible way. Thanks, Subxero for pointing me out - by reference (using &) is PHP 5 and up.  
	reset($membersforthisreputation);
	while (list($key, $value) = each($membersforthisreputation))
	{
		$membersforthisreputation[$key]['standing'] = $Factions_to_en[$value['Clocale']][$value['standing']];
		// Translate faction also
		$membersforthisreputation[$key]['faction'] = $Factions_to_en[$value['Clocale']][$value['faction']];
	}
	
	// We have to sort the membersforthisreputation array manually
	foreach ($membersforthisreputation as $key => $row)
	{
 		$Clocale[$key]  = $row['Clocale'];
		$member[$key] = $row['member'];
		$faction[$key] = $row['faction'];
		$name[$key] = $row['name'];
		$value[$key] = $row['value'];
		$curr_rep[$key] = $row['curr_rep'];
		$max_rep[$key] = $row['max_rep'];
		$standing[$key] = $row['standing'];
	}
	array_multisort($max_rep, SORT_ASC, $standing, SORT_DESC, $curr_rep, SORT_DESC, $membersforthisreputation);
	// ^^


	// Get faction name (i.e. Shattrath City) from first item in table - this is ok because reputation is all identical
	// Do not accept 'Inactive' as a faction name.
	$index = 0;
	do 
	{
		$category = getlanguagefaction($Factions_to_en[$callinglocale], $membersforthisreputation[$index]['faction']);
		$index = $index + 1;
	}
	while($Factions_to_en[$callinglocale][$category] == "Inactive");
	
	// Now, parse all the factions
	$striping_counter = 1;
	$rep = array();
	foreach($membersforthisreputation as $row)
	{
		// $category = $row['faction']; // Have to localize this ... ?
		$standing_enUS = $row['standing']; // Remember, these are all enUS
		$faction = $GetSelectedFaction; // The original 'roster langauge locale' faction name
		$colorstyle = '';
		$imgbar = '';

		switch ($standing_enUS)
		{
			case ($roster->locale->wordings['enUS']['exalted']):
				$colorstyle = 'style=\'color : #007662;\'';
				$imgbar = $addon['image_path'].'/barbit_b.gif';
				break;
			
			case ($roster->locale->wordings['enUS']['revered']):
				$colorstyle = 'style=\'color : #227501;\'';
   		  $imgbar = $addon['image_path'].'/barbit_g.gif';
				break;
				
 			case ($roster->locale->wordings['enUS']['honored']):
				$colorstyle = 'style=\'color : #547301;\'';
				$imgbar = $addon['image_path'].'/barbit_h.gif';
    		break;
    	
			case ($roster->locale->wordings['enUS']['friendly']):
		 		$colorstyle = 'style=\'color : #787701;\'';
				$imgbar = $addon['image_path'].'/barbit_f.gif';
				break;
    	
			case ($roster->locale->wordings['enUS']['neutral']):
				$colorstyle = 'style=\'color : #A48618;\'';
				$imgbar = $addon['image_path'].'/barbit_y.gif';
				break;
    	
			case ($roster->locale->wordings['enUS']['unfriendly']):
				$colorstyle = 'style=\'color : orange;\'';
				$imgbar = $addon['image_path'].'/barbit_o.gif';
				break;
	    
			case ($roster->locale->wordings['enUS']['hostile']):
				$colorstyle = 'style=\'color : #974414;\'';
				$imgbar = $addon['image_path'].'/barbit_host.gif';
				break;
    	
			case ($roster->locale->wordings['enUS']['hated']):
				$colorstyle = 'style=\'color : #FF3333;\'';
				$imgbar = $addon['image_path'].'/barbit_r.gif';
				break;
		}  	

		$percent_exp = ($row['max_rep'] > 0 ? round(($row['curr_rep']/$row['max_rep'])*100) : 0);
	
		// Get our locale back again...
		$standing = getlanguagefaction($Factions_to_en[$roster->config['locale']], $standing_enUS);
		
		if (!array_key_exists($standing, $rep))
   	{
			$rep[$standing] = ('<tr class="membersRow'. ((++$striping_counter % 2) +1) ."\">\n");
		}
		else
		{
			$rep[$standing] .=('<tr class="membersRow'. ((++$striping_counter % 2) +1) ."\">\n");
		}

		$rep[$standing] .=('<td class="membersRow'. (($striping_counter % 2) +1) .'"' . ' ' . $colorstyle . '>'.$row['member'].'</td>');
		$rep[$standing] .=('<td class="membersRow'. (($striping_counter % 2) +1) .'"' . ' ' . $colorstyle . '>'.$standing.'</td>');
		$rep[$standing] .=('<td class="membersRowRight'. (($striping_counter % 2) +1) .'"' . ' ' . $colorstyle . '>'.'<div style="cursor:default;">'.'<div class="levelbarParent" style="width:100px;">'.'<div class="levelbarChild">' . $row['curr_rep'].' / '.$row['max_rep'].'</div>' .  '</div>' . '<table class="expOutline" border="0" cellpadding="0" cellspacing="0" width="100">' . '<tr>' . '<td style="background-image: url(\'' . $imgbar .'\');" width="'. $percent_exp .'%"><img src="img/pixel.gif" height="14" width="1" alt=""></td>' . '<td width="'.(100 - $percent_exp).'%"></td>' . '</tr>' . '</table>' . '</div></td>');
		$rep[$standing] .=('</tr>');
	}

	$borderTop = border('syellow', 'start', $category.' - '.$faction);
	$tableHeader = '<table width="100%" cellspacing="0" class="bodyline">';
	$tableHeaderRow = '	<tr>
		<th class="membersHeader">'.$roster->locale->act['rep_name'].'</th>
		<th class="membersHeader">'.$roster->locale->act['rep_status'].'</th>
		<th class="membersHeaderRight">'.$roster->locale->act['rep_value'].' / '.$roster->locale->act['rep_max'].'</th>
		</tr>';
	$tableFooter = '</table>';
	$borderBottom = border('syellow', 'end',$category.' - '.$faction);

	print $borderTop;
	print $tableHeader;
	print $tableHeaderRow;
	
	function print_array($faction, &$rep)
	{
		if (array_key_exists($faction, $rep))
			print $rep[$faction]; 
	}

	print_array($roster->locale->wordings[$roster->config['locale']]['exalted'],$rep);
	print_array($roster->locale->wordings[$roster->config['locale']]['revered'],$rep);
	print_array($roster->locale->wordings[$roster->config['locale']]['honored'],$rep);
	print_array($roster->locale->wordings[$roster->config['locale']]['friendly'],$rep);
	print_array($roster->locale->wordings[$roster->config['locale']]['neutral'],$rep);
	print_array($roster->locale->wordings[$roster->config['locale']]['unfriendly'],$rep);
	print_array($roster->locale->wordings[$roster->config['locale']]['hostile'],$rep);
	print_array($roster->locale->wordings[$roster->config['locale']]['hated'],$rep);
	
	print $tableFooter;
	print $borderBottom;
}

function getlanguagefaction($FactionsArray, $faction)
{
	foreach($FactionsArray as $key => $value)
	{
		if($faction == $value)
		{
			$faction_local = $key;
			break;
		}
	}
	return $faction_local;
}

?>
