<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @link http://www.wowroster.net
 * @license http://creativecommons.org/licenses/by-nc-sa/2.5/
 * @author Joshua Clark
 * @version $Id: $
 * @copyright 2005-2007 Joshua Clark
 * @package SigGen
 * @subpackage Installer
*/

if ( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

/**
 * Installer for Reputation Addon
 *
 * @package    Reputation
 * @subpackage Installer
 *
 */
class reputationInstall
{
	var $active = true;
	var $icon = 'inv_misc_key_13';
	var $version = '1.9.9.1569';
	
	var $wrnet_id = '0';
	
	var $fullname = 'reputationinfo';
	var $description = 'reputation_desc';
	var $credits = array(
		array(	"name"=>	"Cybrey and tuigii",
				"info"=>	"Lists faction reputation stats"),
		array(	"name"=>	"tuigii",
				"info"=>	"Adapted for Roster V2 beta"),
		);

	/**
	 * Install Function
	 *
	 * @return bool
	 */
	function install()
	{
		global $installer;
		
		# Master data for the config file
		$installer->add_config("'1','startpage','reputation_conf','display','master'");

		# Config menu entries
		$installer->add_config("'110','reputation_conf',NULL,'blockframe','menu'");

		# Generic display settings
		$installer->add_config("'1100', 'reputation_language', '1', 'radio{yes^1|no^0', 'reputation_conf'");

		# Roster menu entry
		$installer->add_menu_button('reputationinfobutton','guild');
		return true;
	}

	/**
	 * Upgrade Function
	 *
	 * @param string $oldversion
	 * @return bool
	 */
	function upgrade($oldversion)
	{
		global $installer;

		// Nothing to upgrade from yet
		return true;
	}

	/**
	 * Un-Install Function
	 *
	 * @return bool
	 */
	function uninstall()
	{
		global $installer;

		$installer->remove_all_config();
		$installer->remove_menu_button('reputationinfobutton');
		return true;
	}
}
